/*
 * extend.sql
 * Rozdzia 6, Oracle10g. Programowanie w jzyku PL/SQL
 * Ron Hardman, Mike McLaughlin i Scott Urman
 *
 * Ten skrypt demonstruje uywanie metody
 * EXTEND z API Collection w Oracle10g dla elementu
 */

SET ECHO ON
SET SERVEROUTPUT ON SIZE 1000000

DECLARE

  -- Definicja tabeli zagniedonej elementw typu INTEGER
  TYPE number_table IS TABLE OF INTEGER;

  -- Definicja zmiennej typu tabeli zagniedonej
  number_list NUMBER_TABLE := number_table(1,2);

  -- Definicja procedury lokalnej pobierajcej i wywietlajcej elementy
  PROCEDURE print_list
    (list_in NUMBER_TABLE) IS

  BEGIN

    -- Przejcie w ptli po moliwych wartociach indeksw listy
    FOR i IN list_in.FIRST..list_in.LAST LOOP

      -- Sprawdzanie, czy element o danym indeksie jest dostpny 
      IF list_in.EXISTS(i) THEN

        -- Wywietlanie elementu
        DBMS_OUTPUT.PUT_LINE('Lista ['||list_in(i)||']');

      END IF;

    END LOOP;

  END print_list;

BEGIN

  -- Wywietlanie nagwka
  DBMS_OUTPUT.PUT_LINE('Tabela zagniedona przed rozszerzeniem');
  DBMS_OUTPUT.PUT_LINE('---------------------------------------');

  -- Wywietlanie listy
  print_list(number_list);

  -- Przydzia dwch pustych elementw
  number_list.EXTEND(2);

  -- Przydzia trzech elementw i kopiowanie do nich drugiego elementu 
  number_list.EXTEND(3,2);

  -- Wywietlenie nagwka
  DBMS_OUTPUT.PUT_LINE(CHR(10)||
                       'Tabela zagniedona po rozszerzeniu');
  DBMS_OUTPUT.PUT_LINE('-----------------------------------');

  -- Wywietlanie listy
  print_list(number_list);

END;
/
